<?php

class ProjectTasksController extends \BaseController {

	/**
	 * Display a listing of the resource.
	 *
	 * @return Response
	 */
	public function index($id)
    {
        $project = Project::find($id);
        $tasks = Task::whereProjectId($id)->get();

        return View::make('tasks.index')
            ->with('tasks', $tasks)
            ->with('project', $project);
	}

	/**
	 * Show the form for creating a new resource.
	 *
	 * @return Response
	 */
	public function create($id)
	{
        return View::make('tasks.create')
            ->with('id', $id);
	}

	/**
	 * Store a newly created resource in storage.
	 *
	 * @return Response
	 */
	public function store($id)
    {
        Task::create([
            'title' => Input::get('title'),
            'completed' => 0,
            'project_id' => $id
        ]);

        return Redirect::route('projects.tasks.index', $id);
	}

	/**
	 * Display the specified resource.
	 *
	 * @param  int  $id
	 * @return Response
	 */
	public function show($id)
	{
		//
	}

	/**
	 * Show the form for editing the specified resource.
	 *
	 * @param  int  $id
	 * @return Response
	 */
	public function edit($id)
	{
		//
	}

	/**
	 * Update the specified resource in storage.
	 *
	 * @param  int  $id
	 * @return Response
	 */
	public function update($id)
	{
		//
	}

	/**
	 * Remove the specified resource from storage.
	 *
	 * @param  int  $id
	 * @return Response
	 */
	public function destroy($projectId, $taskId)
	{
        Task::findOrFail($taskId)->delete();

        return Redirect::route('projects.tasks.index', $projectId);
	}

}
